<template>
  <div>
    <div v-if="mode === 0">
      <el-table :data="studentQuestionList" height="400">
        <el-table-column type="index" :label="$t('LECTURE_LIST.NUMBER')" align="center" width="100">
        </el-table-column>
        <el-table-column prop="type" :label="$t('QUESTION.TYPE')" align="center" width="150">
          <template slot-scope="scope">
            <span v-if="scope.row.type === '단답'">
              {{ $t('QUESTION.SHORT_ANS') }}
            </span>
            <span v-else-if="scope.row.type === '객관'">
              {{ $t('QUESTION.MULTI_ANS') }}
            </span>
            <span v-else-if="scope.row.type === '서술'">
              {{ $t('QUESTION.ESSAY') }}
            </span>
            <span v-else-if="scope.row.type === 'SW'">
              SW
            </span>
            <span v-else-if="scope.row.type === 'SQL'">
              SQL
            </span>
            <span v-else-if="scope.row.type === '파일'">
              {{ $t('QUESTION.FILE') }}
            </span>
          </template>
        </el-table-column>
        <el-table-column prop="name" :label="$t('QUESTION.QUES_NAME')" align="center" width="200">
        </el-table-column>
        <el-table-column prop="submitTime" :label="$t('STUDENT_ASSIGNMENT.INITIAL_SUB_TIME')" align="center" width="350">
        </el-table-column>
        <el-table-column :label="$t('LECTURE_LIST.EDIT')" align="center" width="120">
          <template slot-scope="scope">
            <el-button size="small" @click="onClick('MODIFY', scope.$index)">{{ $t('LECTURE_LIST.EDIT') }}</el-button>
          </template>
        </el-table-column>
        <!-- <el-table-column label="미리보기" align="center" width="130">
          <template slot-scope="scope">
            <el-button size="small" @click="onClick('PREVIEW', scope.$index)">미리보기</el-button>
            <el-dialog
              title="미리보기"
              :visible.sync="dialogVisible"
              :before-close="handleClose"
              center
              width="30%">
              <quiz-preview/>
              <quiz-preview
                :data="modifyQuestion"
                :answer="previewAnswer"/>
              <span slot="footer" class="dialog-footer">
                <el-button @click="handleClose">닫기</el-button>
              </span>
            </el-dialog>
          </template>
        </el-table-column> -->
        <el-table-column :label="$t('LECTURE_LIST.DELETE')" align="center" width="120">
          <template slot-scope="scope">
            <el-button type="danger" size="small" @click="onClick('DELETE', scope.$index)">{{ $t('LECTURE_LIST.DELETE') }}</el-button>
          </template>
        </el-table-column>
        <el-table-column label="" align="center" width="130">
          <template slot-scope="scope">
            <el-button size="small" @click="preView(scope.row)">{{ $t('ITEM.PREVIEW') }}</el-button>
            <!-- <el-dialog
              :title="$t('ITEM.PREVIEW')"
              :visible.sync="dialogVisible"
              :before-close="handleClose"
              center
              width="30%">
              <quiz-preview
                :data="lectureItem"
                :onClick="onClick"
              />
              <template v-for="(item,index) in fileList">
                <div :key="item">
                  <el-button @click="download(index)">{{ item.file_name }}</el-button>
                </div>
              </template>
              <youtube
                v-if="youtubeURL !== undefined && youtubeURL !== ''"
                player-width="100%"
                id="video"
                :video-id="youtubeId(youtubeURL)"
                :player-vars="{ autoplay: 1, modestbranding: 1 }"
              />
              <span slot="footer" class="dialog-footer">
                
                <el-button @click="handleClose">{{ $t('DASHBOARD.QUIT') }}</el-button>
              </span>
            </el-dialog> -->
          </template>
        </el-table-column>
      </el-table>
      <div class="ps-align-right">
        <p><el-button type="primary" @click="onCreate">{{ $t('STUDENT_ASSIGNMENT.CREATE_QUES') }}</el-button></p>
      </div>
      <el-dialog
        :title="$t('ITEM.PREVIEW')"
        :visible.sync="dialogVisible"
        :before-close="handleClose"
        center
        width="30%">
        <lecture-live-item
          :data="lectureItem"
          :onClick="onClick"
          type="TEACHER"/>
          <!-- <div>{{ vm.lectureItem.questions[0].name}}</div> -->
          <!-- <div>{{ vm.lectureItem.questions[0].question}}</div> -->
          <!-- <template v-for="(item,index) in fileList"> -->
            <!-- <div>{{ item.file_name}}</div> -->
            <!-- <div :key="item">
              <el-button @click="download(index)">{{ item.file_name}}</el-button>
            </div>
          </template> -->
        <span slot="footer" class="dialog-footer">
          
          <el-button @click="handleClose">{{ $t('DASHBOARD.QUIT') }}</el-button>
        </span>
      </el-dialog>
      <el-dialog
        :title="$t('ITEM.PREVIEW')"
        :visible.sync="dialogVisibleFile"
        :before-close="handleCloseFile"
        center
        width="30%">
        <template v-for="(item,index) in fileList">
          <!-- <div>{{ item.file_name}}</div> -->
          <div :key="item">
            <el-button @click="download(index)">{{ item.file_name}}</el-button>
          </div>
        </template>
        <youtube
          v-if="youtubeURL !== undefined && youtubeURL !== ''"
          player-width="100%"
          id="video"
          :video-id="youtubeId(youtubeURL)"
          :player-vars="{ autoplay: 1, modestbranding: 1 }"
        />
        <span slot="footer" class="dialog-footer">
          <el-button @click="handleCloseFile">{{ $t('DASHBOARD.QUIT') }}</el-button>
        </span>
      </el-dialog>
    </div>
    
    <div v-else-if="mode === 1">
      <el-button @click="onBack(0)" icon="el-icon-back">{{ $t('BOARD.BACK') }}</el-button>
      <br><br>
      <quiz-new/>
    </div>
    <div v-else-if="mode === 2">
      <el-button @click="onBack(1)" icon="el-icon-back">{{ $t('BOARD.BACK') }}</el-button>
      <br><br>
      <quiz-edit/>
    </div> 
    
  </div>
</template>

<script>
import deepCopy from 'deep-copy';
import { mapState, mapGetters, mapActions, mapMutations } from 'vuex';
import { getIdFromURL } from 'vue-youtube-embed';
import QuizNew from '../partials/QuizNew';
import QuizEdit from '../partials/QuizEdit';
import QuizPreview from '../partials/QuizPreview';
import studentService from '../../services/studentService';
import lectureService from '../../services/lectureService';
import LectureLiveItem from '../partials/LectureLiveItem';

export default {
  name: 'StudentSelfQuiz',
  components: {
    QuizNew,
    QuizEdit,
    QuizPreview,
    studentService,
    LectureLiveItem,
  },
  data() {
    return {
      // mode: 0,  // 0-리스트, 1-등록, 2-수정
      lecId: 0, // lectureId 저장용
      fileList: [], // 파일용
      lectureItem: undefined,
      dialogVisible: false,
      dialogVisibleFile: false,
      youtubeURL: '',
    };
  },
  computed: {
    ...mapState({
      index: state => state.studentQuestion.index,
      studentQuestionList: state => state.studentQuestion.studentQuestionList,
      mode: state => state.studentQuestion.mode,
      lectureId: state => state.studentQuestion.lectureId,
      lectureHomework: state => state.studentQuestion.lectureHomework,
    }),
    // ...mapState('NNclass', ['curLectureId']),
    ...mapState('studentQuestion', ['lectureHomework']),
    ...mapGetters('studentQuestion', ['getIndex']),
  },
  async mounted() {
    const vm = this;
    vm.lecId = vm.lectureId;
    await vm.getQuestionList({ lectureId: vm.lecId });
    vm.updateStudentQuestionMode1({ mode: 0 });
  },
  methods: {
    ...mapActions('studentQuestion', [
      'getQuestionList',
      'deleteQuestion',
      'transferStudentQuestion',
      'updateStudentQuestionMode1',
    ]),
    ...mapMutations('studentQuestion', [
      'updateStudentQuestionIndex',
      'updateStudentQuestionIndex',
      'updateStudentQuestionMode',
      'updateLectureId',
    ]),
    setIndex() {
      this.$store.state.studentQuestion.index = this.q_index;
    },
    handleClose() {
      const vm = this;
      vm.dialogVisible = false;
      vm.lectureItem = undefined;
    },
    handleCloseFile() {
      const vm = this;
      vm.dialogVisibleFile = false;
      vm.lectureItem = undefined;
    },
    youtubeId(URL) {
      return URL !== undefined ? getIdFromURL(URL) : '';
    },
    async preView(data) {
       const vm = this;
      // 해당 문항을 deepCopy로 가져옴
      const ddl = deepCopy(data);
      const thisItem = {};
      thisItem.questions = [];
      thisItem.questions.push(ddl);
      thisItem.type = 0;
      if (ddl.type == '객관') { // 객관식일 경우
        thisItem.questions[0].type = 0;
        thisItem.questions[0].student_answer_logs = [];
        vm.lectureItem = thisItem;
        vm.dialogVisible = true;
      } else if (ddl.type == '파일') { // 파일 형일 경우
        const files = await lectureService.studentQuestionFileList({
          questionId: ddl.student_question_id, lectureId: ddl.lecture_id,
        });
        vm.fileList = files.data;
        vm.lectureItem = thisItem;
        vm.youtubeURL = vm.lectureItem.questions[0].answer;
        vm.dialogVisibleFile = true;
      } else {
        vm.lectureItem = thisItem;
        vm.lectureItem.questions[0].answer = vm.lectureItem.questions[0].answer[0];
        vm.lectureItem.questions[0].choice = vm.lectureItem.questions[0].choice[0];
        vm.lectureItem.questions[0].type = 1;
        vm.lectureItem.questions[0].student_answer_logs = [];
        vm.dialogVisible = true;
      }
    },
    async download(index) {
      const vm = this;
      const obj = vm.fileList[index];
      window.open(obj.file_url);
    },
    async onClick(type, index) {
      const vm = this;
      const lhc = studentService.getLectureHomeworkCheck({
        id: vm.lecId,
      });
      lhc.then(function(res) { // eslint-disable-line
        const currentTime = Date.now();
        const endTime = Date.parse(res.data.lecture.homeworkEndAt);
        const startTime = Date.parse(res.data.lecture.homeworkStartAt);

        if (endTime < currentTime || startTime > currentTime) {
          vm.$notify({
            title: 'Completed',
            message: vm.$t('NOTIFY.HWK_SUB_NOT_TIME'),
            type: 'warning',
            duration: 3000,
          });
          return;
        }
        switch (type) {
          case 'MODIFY' : {
            vm.updateStudentQuestionMode1({ mode: 2 });
            vm.transferStudentQuestion({ index });
            break;
          }
          case 'DELETE' : {
            vm.$confirm(vm.$t('CONFIRM.WANT_DELETE'), 'Delete Quiz', {
              confirmButtonText: vm.$t('NOTE.CONFIRM'),
              cancelButtonText: vm.$t('NOTIFY.CANCEL'),
              type: 'warning',
            }).then(async () => {
              try {
                await vm.deleteQuestion({ lectureId: vm.lecId, index });
                vm.$notify({
                  title: vm.$t('NOTIFY.DELETE_SUCCESS'),
                  message: vm.$t('NOTIFY.ITEM_DELETE'),
                  type: 'success',
                  duration: 3000,
                });
              } catch (error) {
                vm.$notify({
                  title: vm.$t('NOTIFY.DELETE_FAIL'),
                  message: error.toString(),
                  type: 'error',
                  duration: 3000,
                });
              }
            }).catch(() => {
              vm.$notify({
                title: 'Cancel',
                message: vm.$t('NOTIFY.DELETE_CANCEL'),
                type: 'warning',
                duration: 3000,
              });
            });
            break;
          }
          default : {
            break;
          }
        }
      });
    },
    onCreate() {
      const vm = this;
      const lhc = studentService.getLectureHomeworkCheck({
        id: vm.lecId,
      });
      lhc.then(function(res) { // eslint-disable-line
        const currentTime = Date.now();
        const endTime = Date.parse(res.data.lecture.homeworkEndAt);
        const startTime = Date.parse(res.data.lecture.homeworkStartAt);
        if (endTime < currentTime || startTime > currentTime) {
          vm.$notify({
            title: 'Error',
            message: vm.$t('NOTIFY.HWK_SUB_NOT_TIME'),
            type: 'warning',
            duration: 3000,
          });
        } else if (vm.studentQuestionList.length >= 1) {
          vm.$notify({
            title: 'Completed',
            message: vm.$t('NOTIFY.HWK_SUB_COMP'),
            type: 'warning',
            duration: 3000,
          });
        } else {
          vm.updateStudentQuestionMode1({ mode: 1 });
        }
        // vm.updateStudentQuestionMode1({ mode: 1 });
      });
    },
    onBack(type) {
      const vm = this;
      let text = null;
      if (type === 0) {
        text = '생성';
      } else {
        text = '수정';
      }
      if (text === '생성') {
        vm.$confirm(vm.$t('CONFIRM.WANT_GO_BACK'), vm.$t('QUESTION.CREATE') + " " + vm.$t('CONFIRM.CANCEL'), {
          confirmButtonText: vm.$t('NOTE.CONFIRM'),
          cancelButtonText: vm.$t('NOTIFY.CANCEL'),
          type: 'warning',
        }).then(async () => {
          this.updateStudentQuestionMode1({ mode: 0 });
        });
      }
      else if (text === '수정') {
        vm.$confirm(vm.$t('CONFIRM.WANT_GO_BACK'), vm.$t('QUESTION.EDIT') + " " + vm.$t('CONFIRM.CANCEL'), {
          confirmButtonText: vm.$t('NOTE.CONFIRM'),
          cancelButtonText: vm.$t('NOTIFY.CANCEL'),
          type: 'warning',
        }).then(async () => {
          this.updateStudentQuestionMode1({ mode: 0 });
        });
      }
    },
  },
};
</script>